]> git.ipfire.org Git - thirdparty/kernel/linux.git/blame - scripts/link-vmlinux.sh
Merge tag 'nfsd-6.9-2' of git://git.kernel.org/pub/scm/linux/kernel/git/cel/linux
[thirdparty/kernel/linux.git] / scripts / link-vmlinux.sh
CommitLineData
1f2bfbd0 1#!/bin/sh
b2441318 2# SPDX-License-Identifier: GPL-2.0
1f2bfbd0
SR
3#
4# link vmlinux
5#
32164845
MY
6# vmlinux is linked from the objects in vmlinux.a and $(KBUILD_VMLINUX_LIBS).
7# vmlinux.a contains objects that are linked unconditionally.
d151e971
MY
8# $(KBUILD_VMLINUX_LIBS) are archives which are linked conditionally
9# (not within --whole-archive), and do not require symbol indexes added.
1f2bfbd0
SR
10#
11# vmlinux
12# ^
13# |
32164845 14# +--< vmlinux.a
1f2bfbd0 15# |
3a166fc2
NP
16# +--< $(KBUILD_VMLINUX_LIBS)
17# | +--< lib/lib.a + more
18# |
1f2bfbd0
SR
19# +-< ${kallsymso} (see description in KALLSYMS section)
20#
21# vmlinux version (uname -v) cannot be updated during normal
22# descending-into-subdirs phase since we do not yet know if we need to
23# update vmlinux.
24# Therefore this step is delayed until just before final link of vmlinux.
25#
26# System.map is generated to document addresses of all kernel symbols
27
28# Error out on error
29set -e
30
3ec8a5b3
MY
31LD="$1"
32KBUILD_LDFLAGS="$2"
33LDFLAGS_vmlinux="$3"
34
7d153696
MY
35is_enabled() {
36 grep -q "^$1=y" include/config/auto.conf
37}
38
1f2bfbd0
SR
39# Nice output in kbuild format
40# Will be supressed by "make -s"
41info()
42{
c39013ee 43 printf " %-7s %s\n" "${1}" "${2}"
1f2bfbd0
SR
44}
45
1f2bfbd0 46# Link of vmlinux
341dfcf8 47# ${1} - output file
618916a4 48# ${2}, ${3}, ... - optional extra .o files
1f2bfbd0
SR
49vmlinux_link()
50{
618916a4 51 local output=${1}
8f130512
MY
52 local objs
53 local libs
5df77ad6
MY
54 local ld
55 local ldflags
56 local ldlibs
1f2bfbd0 57
d7b0827f
LT
58 info LD ${output}
59
618916a4
AN
60 # skip output file argument
61 shift
62
ed53a0d9 63 if is_enabled CONFIG_LTO_CLANG || is_enabled CONFIG_X86_KERNEL_IBT; then
8f130512
MY
64 # Use vmlinux.o instead of performing the slow LTO link again.
65 objs=vmlinux.o
66 libs=
67 else
32164845 68 objs=vmlinux.a
8f130512
MY
69 libs="${KBUILD_VMLINUX_LIBS}"
70 fi
71
7b453719
MY
72 if is_enabled CONFIG_MODULES; then
73 objs="${objs} .vmlinux.export.o"
74 fi
75
2df8220c
MY
76 objs="${objs} init/version-timestamp.o"
77
5df77ad6
MY
78 if [ "${SRCARCH}" = "um" ]; then
79 wl=-Wl,
80 ld="${CC}"
81 ldflags="${CFLAGS_vmlinux}"
82 ldlibs="-lutil -lrt -lpthread"
83 else
84 wl=
85 ld="${LD}"
86 ldflags="${KBUILD_LDFLAGS} ${LDFLAGS_vmlinux}"
87 ldlibs=
88 fi
89
90 ldflags="${ldflags} ${wl}--script=${objtree}/${KBUILD_LDS}"
91
af73d78b
KC
92 # The kallsyms linking does not need debug symbols included.
93 if [ "$output" != "${output#.tmp_vmlinux.kallsyms}" ] ; then
5df77ad6 94 ldflags="${ldflags} ${wl}--strip-debug"
af73d78b
KC
95 fi
96
7d153696 97 if is_enabled CONFIG_VMLINUX_MAP; then
5df77ad6 98 ldflags="${ldflags} ${wl}-Map=${output}.map"
5cc12472
RV
99 fi
100
5df77ad6
MY
101 ${ld} ${ldflags} -o ${output} \
102 ${wl}--whole-archive ${objs} ${wl}--no-whole-archive \
103 ${wl}--start-group ${libs} ${wl}--end-group \
104 $@ ${ldlibs}
1f2bfbd0
SR
105}
106
e83b9f55 107# generate .BTF typeinfo from DWARF debuginfo
341dfcf8
AN
108# ${1} - vmlinux image
109# ${2} - file to dump raw BTF data into
e83b9f55
AN
110gen_btf()
111{
341dfcf8 112 local pahole_ver
e83b9f55 113
581b31c3 114 if ! [ -x "$(command -v ${PAHOLE})" ]; then
2a67a6cc 115 echo >&2 "BTF: ${1}: pahole (${PAHOLE}) is not available"
341dfcf8 116 return 1
581b31c3
AN
117 fi
118
e83b9f55 119 pahole_ver=$(${PAHOLE} --version | sed -E 's/v([0-9]+)\.([0-9]+)/\1\2/')
21a85bd6
LB
120 if [ "${pahole_ver}" -lt "116" ]; then
121 echo >&2 "BTF: ${1}: pahole version $(${PAHOLE} --version) is too old, need at least v1.16"
341dfcf8 122 return 1
e83b9f55
AN
123 fi
124
341dfcf8 125 vmlinux_link ${1}
af73d78b
KC
126
127 info "BTF" ${2}
9741e07e 128 LLVM_OBJCOPY="${OBJCOPY}" ${PAHOLE} -J ${PAHOLE_FLAGS} ${1}
341dfcf8 129
90ceddcb
FS
130 # Create ${2} which contains just .BTF section but no symbols. Add
131 # SHF_ALLOC because .BTF will be part of the vmlinux image. --strip-all
132 # deletes all symbols including __start_BTF and __stop_BTF, which will
133 # be redefined in the linker script. Add 2>/dev/null to suppress GNU
134 # objcopy warnings: "empty loadable segment detected at ..."
135 ${OBJCOPY} --only-section=.BTF --set-section-flags .BTF=alloc,readonly \
136 --strip-all ${1} ${2} 2>/dev/null
137 # Change e_type to ET_REL so that it can be used to link final vmlinux.
e3a9ee96
NC
138 # GNU ld 2.35+ and lld do not allow an ET_EXEC input.
139 if is_enabled CONFIG_CPU_BIG_ENDIAN; then
140 et_rel='\0\1'
141 else
142 et_rel='\1\0'
143 fi
144 printf "${et_rel}" | dd of=${2} conv=notrunc bs=1 seek=16 status=none
e83b9f55 145}
1f2bfbd0 146
08beb669 147# Create ${2} .S file with all symbols from the ${1} object file
1f2bfbd0
SR
148kallsyms()
149{
1f2bfbd0
SR
150 local kallsymopt;
151
7d153696 152 if is_enabled CONFIG_KALLSYMS_ALL; then
6895f97e 153 kallsymopt="${kallsymopt} --all-symbols"
1f2bfbd0
SR
154 fi
155
7d153696 156 if is_enabled CONFIG_KALLSYMS_ABSOLUTE_PERCPU; then
c6bda7c9
RR
157 kallsymopt="${kallsymopt} --absolute-percpu"
158 fi
159
7d153696 160 if is_enabled CONFIG_KALLSYMS_BASE_RELATIVE; then
2213e9a6
AB
161 kallsymopt="${kallsymopt} --base-relative"
162 fi
163
010a0aad
ZL
164 if is_enabled CONFIG_LTO_CLANG; then
165 kallsymopt="${kallsymopt} --lto-clang"
166 fi
167
08beb669 168 info KSYMS ${2}
aa221f2e 169 scripts/kallsyms ${kallsymopt} ${1} > ${2}
1f2bfbd0
SR
170}
171
8959e392
KC
172# Perform one step in kallsyms generation, including temporary linking of
173# vmlinux.
174kallsyms_step()
175{
176 kallsymso_prev=${kallsymso}
af73d78b
KC
177 kallsyms_vmlinux=.tmp_vmlinux.kallsyms${1}
178 kallsymso=${kallsyms_vmlinux}.o
08beb669 179 kallsyms_S=${kallsyms_vmlinux}.S
8959e392 180
d7b0827f 181 vmlinux_link ${kallsyms_vmlinux} "${kallsymso_prev}" ${btf_vmlinux_bin_o}
ca09bf48 182 mksysmap ${kallsyms_vmlinux} ${kallsyms_vmlinux}.syms ${kallsymso_prev}
94ff2f63 183 kallsyms ${kallsyms_vmlinux}.syms ${kallsyms_S}
08beb669
MY
184
185 info AS ${kallsyms_S}
186 ${CC} ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS} \
187 ${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL} \
188 -c -o ${kallsymso} ${kallsyms_S}
8959e392
KC
189}
190
1f2bfbd0
SR
191# Create map file with all symbols from ${1}
192# See mksymap for additional details
193mksysmap()
194{
94ff2f63 195 info NM ${2}
ca09bf48 196 ${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2} ${3}
1f2bfbd0
SR
197}
198
10916706 199sorttable()
1347a2ce 200{
10916706 201 ${objtree}/scripts/sorttable ${1}
1347a2ce
LT
202}
203
1f2bfbd0 204# Delete output files in case of error
1f2bfbd0
SR
205cleanup()
206{
341dfcf8 207 rm -f .btf.*
1f2bfbd0
SR
208 rm -f System.map
209 rm -f vmlinux
5cc12472 210 rm -f vmlinux.map
1f2bfbd0
SR
211}
212
1f2bfbd0
SR
213# Use "make V=1" to debug this script
214case "${KBUILD_VERBOSE}" in
215*1*)
216 set -x
217 ;;
218esac
219
220if [ "$1" = "clean" ]; then
221 cleanup
222 exit 0
223fi
224
2df8220c
MY
225${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init init/version-timestamp.o
226
7fd78568 227btf_vmlinux_bin_o=""
7d153696 228if is_enabled CONFIG_DEBUG_INFO_BTF; then
af73d78b
KC
229 btf_vmlinux_bin_o=.btf.vmlinux.bin.o
230 if ! gen_btf .tmp_vmlinux.btf $btf_vmlinux_bin_o ; then
da5fb182
SF
231 echo >&2 "Failed to generate BTF for vmlinux"
232 echo >&2 "Try to disable CONFIG_DEBUG_INFO_BTF"
233 exit 1
341dfcf8
AN
234 fi
235fi
236
1f2bfbd0 237kallsymso=""
8959e392 238kallsymso_prev=""
1f2bfbd0 239kallsyms_vmlinux=""
7d153696 240if is_enabled CONFIG_KALLSYMS; then
1f2bfbd0
SR
241
242 # kallsyms support
243 # Generate section listing all symbols and add it into vmlinux
244 # It's a three step process:
2216cf68 245 # 1) Link .tmp_vmlinux.kallsyms1 so it has all symbols and sections,
1f2bfbd0
SR
246 # but __kallsyms is empty.
247 # Running kallsyms on that gives us .tmp_kallsyms1.o with
248 # the right size
2216cf68 249 # 2) Link .tmp_vmlinux.kallsyms2 so it now has a __kallsyms section of
1f2bfbd0
SR
250 # the right size, but due to the added section, some
251 # addresses have shifted.
2216cf68 252 # From here, we generate a correct .tmp_vmlinux.kallsyms2.o
7e2b37c9
NP
253 # 3) That link may have expanded the kernel image enough that
254 # more linker branch stubs / trampolines had to be added, which
255 # introduces new names, which further expands kallsyms. Do another
256 # pass if that is the case. In theory it's possible this results
257 # in even more stubs, but unlikely.
258 # KALLSYMS_EXTRA_PASS=1 may also used to debug or work around
259 # other bugs.
260 # 4) The correct ${kallsymso} is linked into the final vmlinux.
1f2bfbd0
SR
261 #
262 # a) Verify that the System.map from vmlinux matches the map from
263 # ${kallsymso}.
264
8959e392
KC
265 kallsyms_step 1
266 kallsyms_step 2
1f2bfbd0 267
7e2b37c9 268 # step 3
8959e392
KC
269 size1=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso_prev})
270 size2=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso})
7e2b37c9
NP
271
272 if [ $size1 -ne $size2 ] || [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
8959e392 273 kallsyms_step 3
1f2bfbd0
SR
274 fi
275fi
276
d7b0827f 277vmlinux_link vmlinux "${kallsymso}" ${btf_vmlinux_bin_o}
e83b9f55 278
c9a0f3b8 279# fill in BTF IDs
7d153696 280if is_enabled CONFIG_DEBUG_INFO_BTF && is_enabled CONFIG_BPF; then
017dab34
JO
281 info BTFIDS vmlinux
282 ${RESOLVE_BTFIDS} vmlinux
c9a0f3b8
JO
283fi
284
ca09bf48 285mksysmap vmlinux System.map ${kallsymso}
72b3942a 286
7d153696 287if is_enabled CONFIG_BUILDTIME_TABLE_SORT; then
10916706 288 info SORTTAB vmlinux
f14bf6a3
SZ
289 if ! sorttable vmlinux; then
290 echo >&2 Failed to sort kernel tables
291 exit 1
292 fi
1347a2ce
LT
293fi
294
1f2bfbd0 295# step a (see comment above)
7d153696 296if is_enabled CONFIG_KALLSYMS; then
94ff2f63 297 if ! cmp -s System.map ${kallsyms_vmlinux}.syms; then
5369f550 298 echo >&2 Inconsistent kallsyms data
4b3d049f 299 echo >&2 'Try "make KALLSYMS_EXTRA_PASS=1" as a workaround'
1f2bfbd0
SR
300 exit 1
301 fi
302fi
0b956e20
RV
303
304# For fixdep
305echo "vmlinux: $0" > .vmlinux.d